{
    "$graph": [
        {
            "class": "CommandLineTool",
            "id": "#bwa_mem_fqp.cwl",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 50000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "images.sbgenomics.com/bogdang/bwa-kf-bundle:0.1.17"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "bwa mem -K 90000000 -v 3 -t 13 -Y $(inputs.ref.path) -R '$(inputs.rg)' $(inputs.file_R1.path) $(inputs.file_R2.path) | /opt/samblaster/samblaster -i /dev/stdin -o /dev/stdout | /opt/sambamba_0.6.3/sambamba_v0.6.3 view -t 13 -f bam -l 0 -S /dev/stdin | /opt/sambamba_0.6.3/sambamba_v0.6.3 sort -t 13 --natural-sort -m 15GiB --tmpdir ./ -o $(inputs.file_R1.nameroot).unsorted.bam -l 5 /dev/stdin"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#bwa_mem_fqp.cwl/bwa_mem_fqp/file_R1"
                },
                {
                    "type": "File",
                    "id": "#bwa_mem_fqp.cwl/bwa_mem_fqp/file_R2"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".64.amb",
                        ".64.ann",
                        ".64.bwt",
                        ".64.pac",
                        ".64.sa",
                        ".64.alt",
                        "^.dict",
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa"
                    ],
                    "id": "#bwa_mem_fqp.cwl/bwa_mem_fqp/ref"
                },
                {
                    "type": "string",
                    "id": "#bwa_mem_fqp.cwl/bwa_mem_fqp/rg"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.bam"
                    },
                    "id": "#bwa_mem_fqp.cwl/bwa_mem_fqp/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#sambamba_merge_one.cwl",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4096,
                    "coresMin": 30
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "images.sbgenomics.com/bogdang/sambamba:0.6.3"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "${\n    if (inputs.bams.length != 1)\n     return \"/opt/sambamba_0.6.3/sambamba_v0.6.3 merge -t 30 \" + inputs.base_file_name + \".aligned.duplicates_marked.unsorted.bam\"\n    else return \"echo \"\n }"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 1,
                        "shellQuote": false
                    },
                    "id": "#sambamba_merge_one.cwl/sambamba_merge_one/bams"
                },
                {
                    "type": "string",
                    "id": "#sambamba_merge_one.cwl/sambamba_merge_one/base_file_name"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.bam",
                        "outputEval": "${\n    if(inputs.bams.length > 1) return self\n    else return inputs.bams\n}"
                    },
                    "id": "#sambamba_merge_one.cwl/sambamba_merge_one/merged_bam"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#sambamba_sort.cwl",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 30000,
                    "coresMin": 30
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "images.sbgenomics.com/bogdang/sambamba:0.6.3"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "/opt/sambamba_0.6.3/sambamba_v0.6.3 sort -t 30 -m 24G -o $(inputs.base_file_name).$(inputs.suffix).bam $(inputs.bam.path)\nmv $(inputs.base_file_name).$(inputs.suffix).bam.bai $(inputs.base_file_name).$(inputs.suffix).bai\nrm $(inputs.bam.path)"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#sambamba_sort.cwl/sambamba_sort/bam"
                },
                {
                    "type": "string",
                    "id": "#sambamba_sort.cwl/sambamba_sort/base_file_name"
                },
                {
                    "type": "string",
                    "default": "aligned.duplicates_marked.sorted",
                    "id": "#sambamba_sort.cwl/sambamba_sort/suffix"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.bam"
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "format": "#sambamba_sort.cwl/sambamba_sort/BAM",
                    "id": "#sambamba_sort.cwl/sambamba_sort/sorted_bam"
                }
            ]
        },
        {
            "class": "Workflow",
            "id": "#main",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/file_R1_l1"
                },
                {
                    "type": "File",
                    "id": "#main/file_R1_l2"
                },
                {
                    "type": "File",
                    "id": "#main/file_R2_l1"
                },
                {
                    "type": "File",
                    "id": "#main/file_R2_l2"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".64.amb",
                        ".fai",
                        "^.dict",
                        ".64.ann",
                        ".64.bwt",
                        ".64.pac",
                        ".64.sa",
                        ".64.alt",
                        "^.dict",
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa"
                    ],
                    "id": "#main/indexed_reference_fasta"
                },
                {
                    "type": "string",
                    "id": "#main/output_basename"
                },
                {
                    "type": "string",
                    "id": "#main/rg"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/sambamba_sort/sorted_bam",
                    "id": "#main/sorted_bam"
                }
            ],
            "steps": [
                {
                    "run": "#bwa_mem_fqp.cwl",
                    "in": [
                        {
                            "source": "#main/file_R1_l1",
                            "id": "#main/bwa_mem_l1/file_R1"
                        },
                        {
                            "source": "#main/file_R2_l1",
                            "id": "#main/bwa_mem_l1/file_R2"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/bwa_mem_l1/ref"
                        },
                        {
                            "source": "#main/rg",
                            "id": "#main/bwa_mem_l1/rg"
                        }
                    ],
                    "out": [
                        "#main/bwa_mem_l1/output"
                    ],
                    "id": "#main/bwa_mem_l1"
                },
                {
                    "run": "#bwa_mem_fqp.cwl",
                    "in": [
                        {
                            "source": "#main/file_R1_l2",
                            "id": "#main/bwa_mem_l2/file_R1"
                        },
                        {
                            "source": "#main/file_R2_l2",
                            "id": "#main/bwa_mem_l2/file_R2"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/bwa_mem_l2/ref"
                        },
                        {
                            "source": "#main/rg",
                            "id": "#main/bwa_mem_l2/rg"
                        }
                    ],
                    "out": [
                        "#main/bwa_mem_l2/output"
                    ],
                    "id": "#main/bwa_mem_l2"
                },
                {
                    "run": "#sambamba_merge_one.cwl",
                    "in": [
                        {
                            "source": [
                                "#main/bwa_mem_l1/output",
                                "#main/bwa_mem_l2/output"
                            ],
                            "id": "#main/sambamba_merge/bams"
                        },
                        {
                            "source": "#main/output_basename",
                            "id": "#main/sambamba_merge/base_file_name"
                        }
                    ],
                    "out": [
                        "#main/sambamba_merge/merged_bam"
                    ],
                    "id": "#main/sambamba_merge"
                },
                {
                    "run": "#sambamba_sort.cwl",
                    "in": [
                        {
                            "source": "#main/sambamba_merge/merged_bam",
                            "id": "#main/sambamba_sort/bam"
                        },
                        {
                            "source": "#main/output_basename",
                            "id": "#main/sambamba_sort/base_file_name"
                        }
                    ],
                    "out": [
                        "#main/sambamba_sort/sorted_bam"
                    ],
                    "id": "#main/sambamba_sort"
                }
            ]
        }
    ],
    "cwlVersion": "v1.0"
}
